# This template provides supplemental jobs to convert deprecared/removed APIs
# in the current deployments.
#
# Usage
#
# include:
#   - project: shinya.maeda/ci-templates
#     file: map-deprecated-api.gitlab-ci.yml
#
# variables:
#   HELM_VERSION_FOR_MAPKUBEAPIS: "v2" # If you already using Helm3, please specify "v3" instead.

.helm-mapkubeapis:
  extends: .auto-deploy
  stage: deploy
  needs: []
  environment:
    action: prepare
  before_script:
    - export TILLER_NAMESPACE=$KUBE_NAMESPACE
    - |
      if [[ "$HELM_VERSION_FOR_MAPKUBEAPIS" == 'v2' ]]; then
        export HELM_HOST="localhost:44134"
        nohup tiller -listen "${HELM_HOST}" >tiller.log 2>&1 &
      fi
    - helm init --client-only
    - helm plugin install https://github.com/hickeyma/helm-mapkubeapis
  script:
    - |
      if [[ "$HELM_VERSION_FOR_MAPKUBEAPIS" == 'v2' ]]; then
        helm mapkubeapis $CI_ENVIRONMENT_SLUG --release-storage configmaps --tiller-out-cluster --namespace $TILLER_NAMESPACE --v2
      else
        helm mapkubeapis $CI_ENVIRONMENT_SLUG --namespace $TILLER_NAMESPACE
      fi

review:helm-mapkubeapis:
  extends: [.helm-mapkubeapis]
  environment:
    name: review/$CI_COMMIT_REF_NAME
  rules:
    - if: '$CI_KUBERNETES_ACTIVE == null || $CI_KUBERNETES_ACTIVE == ""'
      when: never
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: never
    - if: '$REVIEW_DISABLED'
      when: never
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'
      when: manual

staging:helm-mapkubeapis:
  extends: [.helm-mapkubeapis]
  environment:
    name: staging
  rules:
    - if: '$CI_KUBERNETES_ACTIVE == null || $CI_KUBERNETES_ACTIVE == ""'
      when: never
    - if: '$CI_COMMIT_BRANCH != "master"'
      when: never
    - if: '$STAGING_ENABLED'
      when: manual

production:helm-mapkubeapis:
  extends: [.helm-mapkubeapis]
  environment:
    name: production
  rules:
    - if: '$CI_KUBERNETES_ACTIVE == null || $CI_KUBERNETES_ACTIVE == ""'
      when: never
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: manual
